Index: appendices/dependencies.xml
===================================================================
--- appendices/dependencies.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ appendices/dependencies.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -350,5 +350,5 @@
 
         <seglistitem>
-          <seg>None</seg>
+          <seg>File</seg>
         </seglistitem>
       </segmentedlist>
@@ -692,6 +692,6 @@
 
         <seglistitem>
-          <seg>Bash, Binutils, Coreutils, Diffutils, Gawk, GCC, Glibc, Grep,
-          Make, Sed, and Zlib</seg>
+          <seg>Bash, Binutils, Bzip2, Coreutils, Diffutils, Gawk, GCC, Glibc,
+          Grep, Make, Sed, Xz, and Zlib</seg>
         </seglistitem>
       </segmentedlist>
@@ -2717,5 +2717,5 @@
 
         <seglistitem>
-          <seg>Eudev, GRUB, Kmod, and Man-DB</seg>
+          <seg>Eudev, File, GRUB, Kmod, and Man-DB</seg>
         </seglistitem>
       </segmentedlist>
Index: chapter01/changelog.xml
===================================================================
--- chapter01/changelog.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ chapter01/changelog.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -46,4 +46,50 @@
        -->
     <listitem revision="sysv">
+      <para>2019-12-22</para>
+      <itemizedlist>
+        <listitem>
+          <para>[pierre] - Update to python3-3.8.1. Fixes
+          <ulink url="&lfs-ticket-root;4564">#4564</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[pierre] - Update to file-5.38. Fixes
+          <ulink url="&lfs-ticket-root;4563">#4563</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[pierre] - Update to linux-5.4.6. Fixes
+          <ulink url="&lfs-ticket-root;4562">#4562</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[pierre] - Update to vim-8.2.0024. Part of
+          <ulink url="&lfs-ticket-root;4500">#4500</ulink>.</para>
+        </listitem>
+      </itemizedlist>
+    </listitem>
+
+    <listitem>
+      <para>2019-12-12</para>
+      <itemizedlist>
+        <listitem>
+          <para>[bdubbs] - Update to libcap-2.28. Fixes
+          <ulink url="&lfs-ticket-root;4559">#4559</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to bison-3.5. Fixes
+          <ulink url="&lfs-ticket-root;4561">#4561</ulink>.</para>
+        </listitem>
+      </itemizedlist>
+    </listitem>
+
+    <listitem>
+      <para>2019-12-10</para>
+      <itemizedlist>
+        <listitem>
+          <para>[renodr] - Fix a regression in meson that was causing problems
+          in dependent packages.</para>
+        </listitem>
+      </itemizedlist>
+    </listitem>
+
+    <listitem>
       <para>2019-12-05</para>
       <itemizedlist>
Index: chapter01/whatsnew.xml
===================================================================
--- chapter01/whatsnew.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ chapter01/whatsnew.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -81,7 +81,7 @@
       <para>Expect-&expect-version;</para>
    </listitem>-->
-   <!--<listitem>
+   <listitem>
       <para>File-&file-version;</para>
-   </listitem>-->
+   </listitem>
     <listitem>
       <para>Findutils-&findutils-version;</para>
@@ -147,7 +147,7 @@
       <para>LFS-Bootscripts-&lfs-bootscripts-version;</para>
     </listitem>-->
-    <!--<listitem>
+    <listitem>
       <para>Libcap-&libcap-version;</para>
-    </listitem>-->
+    </listitem>
     <listitem>
       <para>Libelf-&elfutils-version; (from elfutils)</para>
Index: chapter05/bzip2.xml
===================================================================
--- chapter05/bzip2.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ chapter05/bzip2.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -45,5 +45,28 @@
 
     <para>The Bzip2 package does not contain a <command>configure</command>
-    script. Compile and test it with:</para>
+    script. There are two <filename>Makefile</filename>, one for the shared
+    library, and the other for the static library. Since we need both, We
+    do the compilation in two stages. First the shared library:</para>
+
+<screen><userinput remap="make">make -f Makefile-libbz2_so
+make clean</userinput></screen>
+
+    <variablelist>
+      <title>The meaning of the make parameter:</title>
+
+      <varlistentry>
+        <term><parameter>-f Makefile-libbz2_so</parameter></term>
+        <listitem>
+          <para>This will cause Bzip2 to be built using a different
+          <filename>Makefile</filename> file, in this case the
+          <filename>Makefile-libbz2_so</filename> file, which creates a dynamic
+          <filename class="libraryfile">libbz2.so</filename> library and links
+          the Bzip2 utilities against it.</para>
+        </listitem>
+      </varlistentry>
+
+    </variablelist>
+
+    <para>Compile and test the package with:</para>
 
 <screen><userinput remap="make">make</userinput></screen>
@@ -51,5 +74,8 @@
     <para>Install the package:</para>
 
-<screen><userinput remap="install">make PREFIX=/tools install</userinput></screen>
+<screen><userinput remap="install">make PREFIX=/tools install
+cp -v bzip2-shared /tools/bin/bzip2
+cp -av libbz2.so* /tools/lib
+ln -sv libbz2.so.1.0 /tools/lib/libbz2.so</userinput></screen>
 
   </sect2>
Index: chapter06/bison.xml
===================================================================
--- chapter06/bison.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ chapter06/bison.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -40,17 +40,22 @@
   <sect2 role="installation">
     <title>Installation of Bison</title>
-
+<!--
     <para>First, fix a build problem with the current version:</para>
 
 <screen><userinput remap="pre">sed -i '9327 s/mv/cp/' Makefile.in</userinput></screen>
-
+-->
     <para>Prepare Bison for compilation:</para>
 
 <screen><userinput remap="configure">./configure --prefix=/usr --docdir=/usr/share/doc/bison-&bison-version;</userinput></screen>
 
+<!--  I could not find a race condidtion in the current version.
     <para>Compile the package, but work around a race condition in the 
     current version:</para>
 
-<screen><userinput remap="make">make -j1</userinput></screen>
+<screen><userinput remap="make">make -j1</userinput></screen>-->
+
+    <para>Compile the package:</para>
+
+<screen><userinput remap="make">make</userinput></screen>
 
 <!--
Index: chapter06/chapter06.xml
===================================================================
--- chapter06/chapter06.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ chapter06/chapter06.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -27,4 +27,6 @@
 
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="zlib.xml"/>
+  <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="bzip2.xml"/>
+  <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="xz.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="file.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="readline.xml"/>
@@ -40,5 +42,4 @@
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="shadow.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="gcc.xml"/>
-  <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="bzip2.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="pkgconfig.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="ncurses.xml"/>
@@ -61,5 +62,4 @@
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="autoconf.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="automake.xml"/>
-  <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="xz.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="kmod.xml"/>
   <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="gettext.xml"/>
Index: chapter06/meson.xml
===================================================================
--- chapter06/meson.xml	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ chapter06/meson.xml	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -40,4 +40,8 @@
   <sect2 role="installation">
     <title>Installation of Meson</title>
+
+    <para>Apply a fix from upstream to fix a regression:</para>
+
+<screen><userinput remap="pre">sed -i "s@isfile(a)@&amp; and not a.startswith('/dev')@" mesonbuild/interpreter.py</userinput></screen>
 
     <para>Compile Meson with the following command:</para>
Index: general.ent
===================================================================
--- general.ent	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ general.ent	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -1,12 +1,12 @@
-<!ENTITY version         "SVN-20191205">
+<!ENTITY version         "SVN-20191222">
 <!ENTITY short-version   "svn">  <!-- Used below in &blfs-book; 
                                       Change to x.y for release but not -rc releases -->
 <!ENTITY generic-version "development"> <!-- Use "development"  or "x.y[-pre{x}]" -->
 
-<!ENTITY versiond        "20191205-systemd">
+<!ENTITY versiond        "20191222-systemd">
 <!ENTITY short-versiond  "systemd">
 <!ENTITY generic-versiond "systemd"> 
 
-<!ENTITY releasedate     "December 5th, 2019">
+<!ENTITY releasedate     "December 22nd, 2019">
 
 <!ENTITY copyrightdate   "1999-2019"><!-- jhalfs needs a literal dash, not &ndash; -->
Index: packages.ent
===================================================================
--- packages.ent	(revision f0b6f135ff55d8b09952387ad1c3cb755d022c10)
+++ packages.ent	(revision b1e9fd4139974e674ca8079b7dcbd503e7f053b6)
@@ -13,5 +13,5 @@
 <!ENTITY acl-home " ">
 <!ENTITY acl-ch6-du "6.4 MB">
-<!ENTITY acl-ch6-sbu "less than 0.1 SBU">
+<!ENTITY acl-ch6-sbu "0.1 SBU">
 
 <!ENTITY attr-version "2.4.48">
@@ -63,17 +63,18 @@
 <!ENTITY binutils-url "&gnu;binutils/binutils-&binutils-version;.tar.xz">
 <!ENTITY binutils-md5 "9406231b7d9dd93731c2d06cefe8aaf1">
-<!ENTITY binutils-home "&gnu-software;binutils/"><!ENTITY binutils-ch5p1-du "580 MB">
+<!ENTITY binutils-home "&gnu-software;binutils/">
+<!ENTITY binutils-ch5p1-du "659 MB">
 <!ENTITY binutils-ch5p1-sbu "1 SBU">
-<!ENTITY binutils-ch5p2-du "879 MB">
-<!ENTITY binutils-ch5p2-sbu "1.1 SBU">
+<!ENTITY binutils-ch5p2-du "637 MB">
+<!ENTITY binutils-ch5p2-sbu "1.2 SBU">
 <!ENTITY binutils-ch6-du "5.1 GB">
-<!ENTITY binutils-ch6-sbu "7.4 SBU">
-
-<!ENTITY bison-version "3.4.2">
-<!ENTITY bison-size "2,189 KB">
+<!ENTITY binutils-ch6-sbu "7.2 SBU">
+
+<!ENTITY bison-version "3.5">
+<!ENTITY bison-size "2,287 KB">
 <!ENTITY bison-url "&gnu;bison/bison-&bison-version;.tar.xz">
-<!ENTITY bison-md5 "d1ceb9dfde2d03b24a4c1137f7f1b572">
+<!ENTITY bison-md5 "c0230be066069f33c8445766833f3205">
 <!ENTITY bison-home "&gnu-software;bison/">
-<!ENTITY bison-ch5-du "39 MB">
+<!ENTITY bison-ch5-du "42 MB">
 <!ENTITY bison-ch5-sbu "0.3 SBU">
 <!ENTITY bison-ch6-du "39 MB">
@@ -85,5 +86,5 @@
 <!ENTITY bzip2-md5 "67e051268d0c475ea773822f7500d0e5">
 <!--<!ENTITY bzip2-home "http://www.bzip.org/">-->
-<!ENTITY bzip2-ch5-du "6.0 MB">
+<!ENTITY bzip2-ch5-du "6.4 MB">
 <!ENTITY bzip2-ch5-sbu "less than 0.1 SBU">
 <!ENTITY bzip2-ch6-du "7.7 MB">
@@ -184,12 +185,12 @@
 <!ENTITY expect-ch5-sbu "0.1 SBU">
 
-<!ENTITY file-version "5.37">
-<!ENTITY file-size "867 KB">
+<!ENTITY file-version "5.38">
+<!ENTITY file-size "911 KB">
 <!ENTITY file-url "ftp://ftp.astron.com/pub/file/file-&file-version;.tar.gz">
-<!ENTITY file-md5 "80c29aca745466c6c24d11f059329075">
+<!ENTITY file-md5 "3217633ed09c7cd35ed8d04191675574">
 <!ENTITY file-home "https://www.darwinsys.com/file/">
-<!ENTITY file-ch5-du "19 MB">
+<!ENTITY file-ch5-du "20 MB">
 <!ENTITY file-ch5-sbu "0.1 SBU">
-<!ENTITY file-ch6-du "19 MB">
+<!ENTITY file-ch6-du "20 MB">
 <!ENTITY file-ch6-sbu "0.1 SBU">
 
@@ -199,5 +200,5 @@
 <!ENTITY findutils-md5 "731356dec4b1109b812fecfddfead6b2">
 <!ENTITY findutils-home "&gnu-software;findutils/">
-<!ENTITY findutils-ch5-du "36 MB">
+<!ENTITY findutils-ch5-du "39 MB">
 <!ENTITY findutils-ch5-sbu "0.3 SBU">
 <!ENTITY findutils-ch6-du "52 MB">
@@ -227,10 +228,10 @@
 <!ENTITY gcc-md5 "3818ad8600447f05349098232c2ddc78">
 <!ENTITY gcc-home "https://gcc.gnu.org/">
-<!ENTITY gcc-ch5p1-du "3.1 GB">
-<!ENTITY gcc-ch5p1-sbu "12 SBU">
-<!ENTITY gcc-ch5p2-du "3.7 GB">
-<!ENTITY gcc-ch5p2-sbu "15 SBU">
+<!ENTITY gcc-ch5p1-du "3.3 GB">
+<!ENTITY gcc-ch5p1-sbu "9 SBU">
+<!ENTITY gcc-ch5p2-du "3.6 GB">
+<!ENTITY gcc-ch5p2-sbu "13 SBU">
 <!ENTITY gcc-ch6-du "4.2 GB ">
-<!ENTITY gcc-ch6-sbu "95 SBU (with tests)">
+<!ENTITY gcc-ch6-sbu "91 SBU (with tests)">
 <!ENTITY libquadmath-version "0.0.0">
 <!ENTITY libstdcpp-version   "6.0.27">
@@ -258,5 +259,5 @@
 <!ENTITY gettext-home "&gnu-software;gettext/">
 <!ENTITY gettext-ch5-du "300 MB">
-<!ENTITY gettext-ch5-sbu "1.8 SBU">
+<!ENTITY gettext-ch5-sbu "2.0 SBU">
 <!ENTITY gettext-ch6-du "249 MB">
 <!ENTITY gettext-ch6-sbu "2.9 SBU">
@@ -268,7 +269,7 @@
 <!ENTITY glibc-home "&gnu-software;libc/">
 <!ENTITY glibc-ch5-du "896 MB">
-<!ENTITY glibc-ch5-sbu "4.8 SBU">
-<!ENTITY glibc-ch6-du "3.3 GB">
-<!ENTITY glibc-ch6-sbu "21 SBU">
+<!ENTITY glibc-ch5-sbu "4.6 SBU">
+<!ENTITY glibc-ch6-du "3.2 GB">
+<!ENTITY glibc-ch6-sbu "20 SBU">
 <!ENTITY libthread_db-version "1.0">
 
@@ -397,8 +398,8 @@
 <!ENTITY lfs-bootscripts-ch7-sbu "less than 0.1 SBU">
 
-<!ENTITY libcap-version "2.27">
-<!ENTITY libcap-size "67 KB">
+<!ENTITY libcap-version "2.28">
+<!ENTITY libcap-size "93 KB">
 <!ENTITY libcap-url "&kernel;linux/libs/security/linux-privs/libcap2/libcap-&libcap-version;.tar.xz">
-<!ENTITY libcap-md5 "2e8f9fab32eb5ccb37969fe317fd17aa">
+<!ENTITY libcap-md5 "4066ddca53fb7e146f98372c8e43afc4">
 <!ENTITY libcap-home "https://sites.google.com/site/fullycapable/">
 <!ENTITY libcap-ch6-du "1.5 MB">
@@ -431,10 +432,10 @@
 <!ENTITY linux-major-version "5">
 <!ENTITY linux-minor-version "4">
-<!ENTITY linux-patch-version "2">
+<!ENTITY linux-patch-version "6">
 <!--<!ENTITY linux-version "&linux-major-version;.&linux-minor-version;">-->
 <!ENTITY linux-version "&linux-major-version;.&linux-minor-version;.&linux-patch-version;">
-<!ENTITY linux-size "106,884 KB">
+<!ENTITY linux-size "106,889 KB">
 <!ENTITY linux-url "&kernel;linux/kernel/v&linux-major-version;.x/linux-&linux-version;.tar.xz">
-<!ENTITY linux-md5 "07a4df090466eb7b24eec5fe4fbd5500">
+<!ENTITY linux-md5 "d77c45902ea8cdbbffed46ae92ae5ec8">
 <!ENTITY linux-home "https://www.kernel.org/">
 <!-- measured for 4.8.3 / gcc-6.2.0 on x86_64 : minimum is
@@ -445,7 +446,7 @@
 
 <!ENTITY linux-headers-ch5-du "1 GB">
-<!ENTITY linux-headers-ch5-sbu "0.1 SBU">
+<!ENTITY linux-headers-ch5-sbu "0.2 SBU">
 <!ENTITY linux-headers-ch6-du "1 GB">
-<!ENTITY linux-headers-ch6-sbu "0.1 SBU">
+<!ENTITY linux-headers-ch6-sbu "0.2 SBU">
 
 <!ENTITY linux-firmware-version "20191026">
@@ -464,6 +465,6 @@
 <!ENTITY m4-ch5-du "20 MB">
 <!ENTITY m4-ch5-sbu "0.2 SBU">
-<!ENTITY m4-ch6-du "33 MB">
-<!ENTITY m4-ch6-sbu "0.4 SBU">
+<!ENTITY m4-ch6-du "20 MB">
+<!ENTITY m4-ch6-sbu "0.2 SBU">
 
 <!ENTITY make-version "4.2.1">
@@ -522,6 +523,6 @@
 <!ENTITY ncurses-md5 "98c889aaf8d23910d2b92d65be2e737a">
 <!ENTITY ncurses-home "&gnu-software;ncurses/">
-<!ENTITY ncurses-ch5-du "41 MB">
-<!ENTITY ncurses-ch5-sbu "0.6 SBU">
+<!ENTITY ncurses-ch5-du "40 MB">
+<!ENTITY ncurses-ch5-sbu "0.7 SBU">
 <!ENTITY ncurses-ch6-du "42 MB">
 <!ENTITY ncurses-ch6-sbu "0.4 SBU">
@@ -559,5 +560,5 @@
 <!ENTITY perl-home "https://www.perl.org/">
 <!ENTITY perl-ch5-du "275 MB">
-<!ENTITY perl-ch5-sbu "1.6 SBU">
+<!ENTITY perl-ch5-sbu "1.4 SBU">
 <!ENTITY perl-ch6-du "272 MB">
 <!ENTITY perl-ch6-sbu "9.9 SBU">
@@ -590,17 +591,17 @@
      meson pages will be needed: python3.6 and python3.6m -->
 
-<!ENTITY python-version "3.8.0">
+<!ENTITY python-version "3.8.1">
 <!ENTITY python-minor "3.8">
-<!ENTITY python-size "17,412 KB">
+<!ENTITY python-size "17,411 KB">
 <!ENTITY python-url "https://www.python.org/ftp/python/&python-version;/Python-&python-version;.tar.xz">
-<!ENTITY python-md5 "dbac8df9d8b9edc678d0f4cacdb7dbb0">
+<!ENTITY python-md5 "b3fb85fd479c0bf950c626ef80cacb57">
 <!ENTITY python-home "https://www.python.org/">
-<!ENTITY python-ch5-du "381 MB">
-<!ENTITY python-ch5-sbu "1.4 SBU">
+<!ENTITY python-ch5-du "408 MB">
+<!ENTITY python-ch5-sbu "1.2 SBU">
 <!ENTITY python-ch6-du "399 MB">
 <!ENTITY python-ch6-sbu "1.3 SBU">
-<!ENTITY python-docs-url "https://docs.python.org/ftp/python/doc/&python-version;/python-&python-version;-docs-html.tar.bz2">
-<!ENTITY python-docs-md5 "2d6a7a58a7b4bccbde48174e0ad0ebbc">
-<!ENTITY python-docs-size "6,358 KB">
+<!ENTITY python-docs-url "https://docs.python.org/3/archives/&python-version;/python-&python-version;-docs-html.tar.bz2">
+<!ENTITY python-docs-md5 "01c826bfe13fd29f4cb954dcf71892ae">
+<!ENTITY python-docs-size "6,426 KB">
 
 <!ENTITY readline-version "8.0">
@@ -678,5 +679,5 @@
 <!ENTITY tcl-md5 "97c55573f8520bcab74e21bfd8d0aadc">
 <!ENTITY tcl-home "http://tcl.sourceforge.net/">
-<!ENTITY tcl-ch5-du "71 MB">
+<!ENTITY tcl-ch5-du "72 MB">
 <!ENTITY tcl-ch5-sbu "0.9 SBU">
 
@@ -714,10 +715,10 @@
 <!ENTITY util-linux-ch6-sbu "1.2 SBU">
 
-<!ENTITY vim-version "8.1.2361">
-<!ENTITY vim-majmin "81">
-<!ENTITY vim-docdir "vim/vim81">
-<!ENTITY vim-size "14,267 KB">
+<!ENTITY vim-version "8.2.0024">
+<!ENTITY vim-majmin "82">
+<!ENTITY vim-docdir "vim/vim82">
+<!ENTITY vim-size "14,307 KB">
 <!ENTITY vim-url "https://github.com/vim/vim/archive/v&vim-version;/vim-&vim-version;.tar.gz">
-<!ENTITY vim-md5 "7813b45901af53f81abeaf3c67ae9b34">
+<!ENTITY vim-md5 "a1b5e7ae3ce2847dbd8672e6dd882750">
 <!ENTITY vim-home "https://www.vim.org">
 <!ENTITY vim-ch6-du "190 MB">
@@ -739,5 +740,5 @@
 <!ENTITY xz-ch5-du "18 MB">
 <!ENTITY xz-ch5-sbu "0.2 SBU">
-<!ENTITY xz-ch6-du "16 MB">
+<!ENTITY xz-ch6-du "14 MB">
 <!ENTITY xz-ch6-sbu "0.2 SBU">
 
